const path = require('path');

let loadedPlugins;

/**
 * Load plugins (all, or by type like "command")
 */
module.exports = (cwd, marenJson, type) => {
  const pluginsList = marenJson && marenJson['plugins'];
  if (!pluginsList) {
    return [];
  }

  if (!loadedPlugins) {
    loadedPlugins = pluginsList.map(
      pluginName => require(path.join(cwd, 'node_modules', pluginName)));
  }

  const plugins = type
    ? loadedPlugins.filter(plugin => plugin.type === type)
    : loadedPlugins;

  return plugins;
};
