const path = require('path');
const optionsJson = require('../config').optionsJson;

module.exports = (cwd, themeName) => {
  const name = themeName;
  const location = path.join(cwd, 'themes', themeName);

  let template;
  try {
    template = require(`${location}/template.js`);
  } catch (e) {
    console.log(`Unknown theme: ${themeName}`);
    process.exit(1);
  }

  const options = optionsJson(location) || {};

  const theme = {
    name,
    location,
    template,
    options
  };

  return theme;
};
